function varargout = EEMlab(varargin)
% EEMLAB MATLAB code for EEMlab.fig
%      EEMLAB, by itself, creates a new EEMLAB or raises the existing
%      singleton*.
%
%      H = EEMLAB returns the handle to a new EEMLAB or the handle to
%      the existing singleton*.
%
%      EEMLAB('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in EEMLAB.M with the given input arguments.
%
%      EEMLAB('Property','Value',...) creates a new EEMLAB or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before EEMlab_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to EEMlab_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help EEMlab

% Last Modified by GUIDE v2.5 25-Mar-2015 20:49:01

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @EEMlab_OpeningFcn, ...
                   'gui_OutputFcn',  @EEMlab_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end
if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

%% EEMlab functions

% --------------------------------------------------------------------
% --- Executes just before EEMlab is made visible.
function EEMlab_OpeningFcn(hObject, eventdata, handles, varargin)
newhandles = appConfig(handles,'config.txt');
handles = newhandles;
handles.EEMlab.Name = [handles.config.appname ' ' handles.config.appversion];
handles.EEMlab.CloseRequestFcn = @appClose; % IMPORTANT! see 'appClose' function
handles.output = hObject; % Choose default command line output for eems
guidata(hObject, handles); % update handles structure

% --------------------------------------------------------------------
% --- Outputs from this function are returned to the command line
function varargout = EEMlab_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on EEMplot_slider movement
function EEMlab_slider_Callback(hObject, eventdata, handles)
% PLOTS
if (strcmp(handles.plt_dset_2D.Checked,'on'))
    dim = '2D';
elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
    dim = '3D';
end
pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
    handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
    handles.EEMlab_info);
guidata(hObject, handles); % update handles structure

% --------------------------------------------------------------------
function eem_about_Callback(hObject, eventdata, handles)
eemAbout(handles.config);

% --------------------------------------------------------------------
function eem_help_Callback(hObject, eventdata, handles)
stat = web('eemHelp.html','-noaddressbox');
if stat ~= 0
    err = {'Could not find or start system browser'};
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> EEMlab:Help';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'EEMlab:Help ...FAIL!'}];
end

% --------------------------------------------------------------------
%% LOAD functions

% --------------------------------------------------------------------
function lod_conf_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newloads,info] = lodConf(handles.loads);
if newloads.config.updated
    % APP config
    handles.loads = newloads;
    if (handles.loads.config.meta.value == 1) % ALL loads to do!!!
        setMenu('on',handles.lod_dset_meta,handles.exp_close,handles.exp_inscom,handles.exp_log);
        % GUI config
        handles.config.log{end+1} = ' ';
        handles.config.log{end+1} = '--> Load:Configuration';
        handles.config.log{end+1} = ['Date: ' date];
        handles.config.log{end+1} = 'Configure loads and format files';
        handles.config.log = [handles.config.log,info{:}];
        handles.config.log{end+1} = 'Load:Configuration ...DONE!';
    end
end
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
guidata(hObject, handles); % update handles structure

% --------------------------------------------------------------------
function lod_dset_meta_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newsamplelog,newdatadir,err] = lodDsetMeta(handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.samplelog = newsamplelog;
    handles.config.datadir = newdatadir;
    cd(handles.config.datadir); % set app in HOME directory (datadir)
    % MENU config
    handles.loads.config.meta.enable = 'off';
    setMenu('on',handles.lod_dset_eems);
    setMenu('off',handles.lod_dset_meta);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Metadata';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'EEM metadata loaded from a samplelog file';
    handles.config.log{end+1} = 'Load:Metadata ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Metadata';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Metadata ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_dset_eems_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newdata,newloads,err] = lodDsetEems(handles.data,handles.loads,handles.samplelog);
if isempty(err)
    % APP config
    handles.data = newdata;
    handles.loads = newloads;
    % MENU config
    handles.loads.config.eems.enable = 'off';
    handles.loads.config.fluor.enable = 'off';
    setMenu('on',handles.eem,handles.lod,handles.dset,handles.plt_dset,handles.exp_save);
    setMenu('off',handles.lod_dset_eems,handles.mdls);
    % TOOLBAR config
    setToolbar(handles,'on');
    % GUI config
    nSamp = handles.data.nSample;
    if nSamp > 1
        set(handles.EEMlab_slider,'Min',1, 'Max',nSamp);
        set(handles.EEMlab_slider, 'SliderStep',[1/(nSamp-1), 1/(nSamp-1)]);
        set(handles.EEMlab_slider,'Visible','on');
    end
    set(handles.EEMlab_info, 'Visible','on');
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Dataset EEMs';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'EEM files loaded in dataset';
    handles.config.log{end+1} = 'Load:Dataset EEMs ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Dataset EEMs';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Dataset EEMs ...FAIL!'}];
end
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_dset_tags_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newdata,err] = lodDsetTags(handles.data,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    handles.loads.config.tag.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Tags';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'tags loaded from metadata file';
    handles.config.log{end+1} = 'Load:Tags ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Tags';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Tags ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_corr_spec_ex_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newloads,err] = lodCorrSpecEx(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.Excor.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Spectral corrections:Excitation scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'EX spectral correction scans loaded';
    handles.config.log{end+1} = 'Load:Corrections:Spectral corrections:Excitation scans ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Spectral corrections:Excitation scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Corrections:Spectral corrections:Excitation scans ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_corr_spec_em_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newloads,err] = lodCorrSpecEm(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.Emcor.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Spectral corrections:Emission scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'EM spectral correction scans loaded';
    handles.config.log{end+1} = 'Load:Corrections:Spectral corrections:Emission scans ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Spectral corrections:Emission scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Corrections:Spectral corrections:Emission scans ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_corr_dil_blanks_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
defaultT = (handles.loads.config.T.value == 0);
[newloads,err] = lodCorrDilBlanks(handles.data,handles.loads,handles.samplelog,defaultT);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.B.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Dilution:Blank files';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Blank files loaded';
    handles.config.log{end+1} = 'Load:Corrections:Dilution:Blank files ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Dilution:Blank files';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Corrections:Dilution:Blank files ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_corr_dil_factors_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newloads,err] = lodCorrDilFactors(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.dilfac.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Dilution:Factors';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'load of dilution factors';
    handles.config.log{end+1} = 'Load:Corrections:Dilution:Factors ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Dilution:Factors';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Corrections:Dilution:Factors ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_corr_ife_abs_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newloads,err] = lodCorrIfeAbs(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.A.enable = 'off';
    handles.loads.config.spect.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Inner filter effect:Absorbance scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Absorbance scans loaded';
    handles.config.log{end+1} = 'Load:Corrections:Inner filter effect:Absorbance scans ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Inner filter effect:Absorbance scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Corrections:Inner filter effect:Absorbance scans ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_calib_qs_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newloads,err] = lodCalibQs(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.Q.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Calibration files:QS dilution series slope';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'QS dilution series slope values loaded';
    handles.config.log{end+1} = 'Load:Calibration files:QS dilution series slope ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Calibration files:QS dilution series slope';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Calibration files:QS dilution series slope ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_norm_dsram_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newloads,err] = lodNormDsRam(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.W.enable = 'off';
    handles.loads.config.landa.enable = 'off';
    handles.loads.config.landa_label.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Normalization:Dataset water Raman scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'A.L. Lawaetz, C.A. Stedmon, "Fluorescence Intensity Calibration Using the Raman Scatter Peak of Water", Appl. Spectrosc., vol. 63, number 8, (2009) 936-940';
    handles.config.log{end+1} = 'load of all dataset Raman scans';
    handles.config.log{end+1} = 'Load:Normalization:Dataset water Raman scans ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Normalization:Dataset water Raman scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Normalization:Dataset water Raman scans ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_norm_blkram_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newloads,err] = lodNormBlkRam(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.T.enable = 'off';
    handles.loads.config.landa.enable = 'off';
    handles.loads.config.landa_label.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Normalization:Dataset dilution water Raman scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'A.L. Lawaetz, C.A. Stedmon, "Fluorescence Intensity Calibration Using the Raman Scatter Peak of Water", Appl. Spectrosc., vol. 63, number 8, (2009) 936-940';
    handles.config.log{end+1} = 'load of all QS dilution water Raman scans';
    handles.config.log{end+1} = 'Load:Normalization:Dataset dilution water Raman scans ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Normalization:Dataset dilution water Raman scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Normalization:Dataset dilution Raman scans ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function lod_norm_qsram_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newloads,err] = lodNormQsRam(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.loads = newloads;
    % MENU config
    handles.loads.config.Qw.enable = 'off';
    handles.loads.config.landa.enable = 'off';
    handles.loads.config.landa_label.enable = 'off';
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Normalization:QS series water Raman scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'A.L. Lawaetz, C.A. Stedmon, "Fluorescence Intensity Calibration Using the Raman Scatter Peak of Water", Appl. Spectrosc., vol. 63, number 8, (2009) 936-940';
    handles.config.log{end+1} = 'K.R. Murphy, et al., "Measurement of Dissolved Organic Matter Fluorescence in Aquatic Environments: An Interlaboratory Comparison", Environ. Sci. Technol. 2010, 44, 9405-9412';
    handles.config.log{end+1} = 'load of all QS dilution series Raman scans';
    handles.config.log{end+1} = 'Load:Normalization:QS series water Raman scans ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Normalization:QS series water Raman scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Normalization:QS series water Raman scans ...FAIL!'}];
end
guidata(hObject, handles);


%% EXPERIMENT functions

% --------------------------------------------------------------------
function exp_load_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newdata,newloads,newsamplelog,newdatadir,newlog,err] = expLoad();
if isempty(err)
    % displays the configuration of the loaded experiment
    % user can change experiment config in order to load new files
    [newloads,~] = lodConf(newloads);
    % APP config
    handles.data = newdata;
    handles.loads = newloads;
    handles.samplelog = newsamplelog;
    handles.config.datadir = newdatadir;
    cd(handles.config.datadir); % set app in HOME directory (datadir)
    % MENU config
    setMenu('on',handles.eem,handles.lod,handles.dset,handles.mdls,handles.plt,handles.exp);
    if isfield(handles.data,'Xnotscaled')   % ALREADY normalized dataset
        setMenu('off',handles.dset_norm_fwd);
    else                                    % dataset NOT normalized
        setMenu('off',handles.dset_norm_rvs);
    end
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
    % TOOLBAR config
    setToolbar(handles,'on');
    % GUI config
    nSamp = handles.data.nSample;
    set(handles.EEMlab_slider,'Min',1, 'Max',nSamp);
    set(handles.EEMlab_slider, 'SliderStep',[1/(nSamp-1), 1/(nSamp-1)]);
    set(handles.EEMlab_slider,'Visible','on');
    set(handles.EEMlab_info, 'Visible','on');
    handles.config.log = newlog;
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Experiment:Load MAT file';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'experiment loaded from a .MAT file';
    handles.config.log{end+1} = 'Experiment:Load MAT file ...DONE';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Experiment:Load MAT file';
    handles.config.log{end+1} = ['Date: ' date];
    %    handles.config.log =  handles.config.log(1:end-2);
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Experiment:Load MAT file ...FAIL!'}];
end
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
guidata(hObject, handles); % update handles structure

% --------------------------------------------------------------------
function exp_save_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newoutputdir,etime,err] = expSaveMat(handles.data,handles.loads,handles.samplelog,handles.config.log,handles.config.datadir);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    handles.config.outputdir = newoutputdir;
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Experiment:Save as MAT file';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'experiment saved in a .MAT file';
    handles.config.log{end+1} = ['Elapsed time: ' etime];
    handles.config.log{end+1} = 'Experiment:Save as MAT file ...DONE';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Experiment:Save as MAT file';
    handles.config.log{end+1} = ['Date: ' date];
    %    handles.config.log =  handles.config.log(1:end-2);
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Experiment:Save as MAT file ...FAIL!'}];
end
guidata(hObject, handles); % update handles structure

% --------------------------------------------------------------------
function exp_close_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
newhandles = appConfig(handles,'config.txt');
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
handles = newhandles;
guidata(hObject, handles); % update handles structure

% --------------------------------------------------------------------
function exp_log_Callback(hObject, eventdata, handles)
cd(handles.config.datadir);
expLog(handles.config.log);

% --------------------------------------------------------------------
function exp_inscom_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newcomment,err] = expInsCom();
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Insert comment';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        newcomment{:}, ...
        {'Dataset:Insert comment ...DONE!'}];
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Insert comment';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Insert comment ...FAIL!'}];
end
guidata(hObject, handles);


%% DATASET functions

% --------------------------------------------------------------------
function dset_corr_spec_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
% we use RAW EEM data to perform SPECTRUM (correction step 1)
[newdata,err] = dsetCorrSpec(handles.loads.rawEEMs,handles.loads);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset,handles.exp,handles.mdls_expl);
    % setMenu('off',handles.mdls);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:Spectrum';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'dataset corrected with EEMlab''s ''fdomcorrect012_spect'' function';
    handles.config.log{end+1} = 'Dataset:Correct:Spectrum ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:Spectrum';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Correct:Spectrum ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_corr_ife_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
% we use RAW EEM data to perform IFE (correction step 2)
[newdata,err] = dsetCorrIfe(handles.loads.rawEEMs,handles.loads);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset,handles.exp,handles.mdls_expl);
    % setMenu('off',handles.mdls);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:InnerFilterEffect';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'dataset corrected with EEMlab''s ''fdomcorrect012_sbs_ife'' function';
    handles.config.log{end+1} = 'Dataset:Correct:InnerFilterEffect ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:InnerFilterEffect';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Correct:InnerFilterEffect ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_corr_norm_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
% we use RAW EEM data to perform NORMALIZATION (correction step 3)
[newdata,err] = dsetCorrNorm(handles.loads.rawEEMs,handles.loads);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset,handles.exp,handles.mdls_expl);
    % setMenu('off',handles.mdls);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:RamanNormalization';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'dataset corrected with EEMlab''s ''fdomcorrect012_sbs_norm'' function';
    handles.config.log{end+1} = 'Dataset:Correct:RamanNormalization ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:RamanNormalization';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Correct:RamanNormalization ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_corr_blk_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
% we use RAW EEM data to perform NORMALIZATION (correction step 3)
[newdata,err] = dsetCorrBlk(handles.loads.rawEEMs,handles.loads);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset,handles.exp,handles.mdls_expl);
    % setMenu('off',handles.mdls);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:BlankSubtraction';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'dataset corrected with EEMlab''s ''fdomcorrect012_sbs_blk'' function';
    handles.config.log{end+1} = 'Dataset:Correct:BlankSubtraction ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:BlankSubtraction';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Correct:BlankSubtraction ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_corr_qs_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
% we use RAW EEM data to perform NORMALIZATION (correction step 3)
[newdata,err] = dsetCorrQs(handles.loads.rawEEMs,handles.loads);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset,handles.exp,handles.mdls_expl);
    % setMenu('off',handles.mdls);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:QsCalibration';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'dataset corrected with EEMlab''s ''fdomcorrect012_sbs_qs'' function';
    handles.config.log{end+1} = 'Dataset:Correct:QsCalibration ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct:QsCalibration';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Correct:QsCalibration ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_dwsample_ex_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetDwsampleEx(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Downsample excitation wavelengths';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'the excitation wavelengths are downsampled for all the EEMs';
    handles.config.log{end+1} = 'Dataset:Downsample excitation wavelengths ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Downsample excitation wavelengths';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Downsample excitation wavelengths ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_dwsample_em_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetDwsampleEm(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Downsample emission wavelengths';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'the emission wavelengths are downsampled for all the EEMs';
    handles.config.log{end+1} = 'Dataset:Downsample emission wavelengths ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Downsample emission wavelengths';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Downsample emission wavelengths ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_resize_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetResize(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Resize';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'all the spectrums resized to the new ROI';
    handles.config.log{end+1} = 'Dataset:Resize ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Resize';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Resize ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_rmscatter_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetRmScatter(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Remove scattering';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Rayleigh and Raman scattering effects removed';
    handles.config.log{end+1} = 'Dataset:Remove scattering ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Remove scattering';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Remove scattering ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_rmout_cmp_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetRmOutByComp(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % GUI config
    nSamp = handles.data.nSample;
    if nSamp > 2
        set(handles.EEMlab_slider,'Min',1, 'Max',nSamp);
        set(handles.EEMlab_slider, 'SliderStep',[1/(nSamp-1), 1/(nSamp-1)]);
        set(handles.EEMlab_slider,'Visible','on');
    end
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Remove outliers by components';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'selected outliers are removed from data struct';
    handles.config.log{end+1} = 'Dataset:Remove outliers by component ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end   
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Remove outliers by components';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Remove outliers by component ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_rmout_tag_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetRmOutByTag(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % GUI config
    nSamp = handles.data.nSample;
    if nSamp > 2
        set(handles.EEMlab_slider,'Min',1, 'Max',nSamp);
        set(handles.EEMlab_slider, 'SliderStep',[1/(nSamp-1), 1/(nSamp-1)]);
        set(handles.EEMlab_slider,'Visible','on');
    end
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Remove outliers by tag';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'selected outliers are removed from data struct';
    handles.config.log{end+1} = 'Dataset:Remove outliers by tag ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Remove outliers by tag';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Remove outliers by tag ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_corrsamp_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetCorrSamp(handles.data,floor(handles.EEMlab_slider.Value));
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct sample';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'faulty values of selected sample are corrected';
    handles.config.log{end+1} = 'Dataset:Correct sample ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Correct sample';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Correct sample ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_norm_fwd_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetNorm(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('off',handles.dset_norm_fwd);
    setMenu('on',handles.mdls);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Normalize:Forward';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'EEM intensity values are normalized to unit variance';
    handles.config.log{end+1} = 'Dataset:Normalize:Forward ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Normalize:Forward';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Normalize:Forward ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function dset_norm_rvs_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = dsetNormRvs(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset_norm_fwd);
    setMenu('off',handles.dset_norm_rvs,handles.mdls); % reverse the normalization is the last step before exporting the results
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Normalize:Reverse';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'EEM intensity values are normalised';
    handles.config.log{end+1} = 'Dataset:Normalize:Reverse ...DONE!';
    % PLOTS
    if (strcmp(handles.plt_dset_2D.Checked,'on'))
        dim = '2D';
    elseif (strcmp(handles.plt_dset_3D.Checked,'on'))
        dim = '3D';
    end
    pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
        handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
    pltDsetInfo(handles.data,floor(handles.EEMlab_slider.Value), ...
        handles.EEMlab_info);
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Dataset:Normalize:Reverse';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Dataset:Normalize:Reverse ...FAIL!'}];
end
guidata(hObject, handles);

%% MODEL functions

% --------------------------------------------------------------------
function mdls_list_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = mdlsList(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:List';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Models:List ...FAIL!'}];
end

% --------------------------------------------------------------------
function mdls_expl_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,etime,err] = mdlsExpl(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset_norm_rvs,handles.plt_mdl);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Exploratory analysis';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Fast PARAFAC modeling for exploratory analysis';
    handles.config.log{end+1} = ['Elapsed time: ' etime];
    handles.config.log{end+1} = 'Models:Exploratory analysis ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Exploratory analysis';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Models:Exploratory analysis ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function mdls_ref_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on';
[newdata,etime,err] = mdlsRef(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset_norm_rvs,handles.plt_mdl);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Refine models';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Run PARAFAC multiple times to identify the least squares solution';
    handles.config.log{end+1} = 'Several models are initialised with random values';
    handles.config.log{end+1} = ['Elapsed time: ' etime];
    handles.config.log{end+1} = 'Models:Refine models ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Refine models';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Models:Refine models ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function mdls_sha_splitds_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = mdlsSplitDs(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset_norm_rvs,handles.plt_mdl);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Split half analysis:Split dataset';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Splits dataset to get new test datasets';
    handles.config.log{end+1} = 'Models:Split half analysis:Split dataset ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Split half analysis:Split dataset';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Models:Split half analysis:Split dataset ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function mdls_sha_model_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,etime,err] = mdlsSha(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset_norm_rvs,handles.plt_mdl);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Split half analysis:Model the splits';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Generate PARAFAC models nested in dataset splits';
    handles.config.log{end+1} = ['Elapsed time: ' etime];
    handles.config.log{end+1} = 'Models:Split half analysis:Model the splits ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Split half analysis:Model the splits';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Models:Split half analysis:Model the splits ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function mdls_val_splits_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = mdlsValSplits(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset_norm_rvs,handles.plt_mdl);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Validations:Validate the splits';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Compare the Ex/Em spectra from PARAFAC models of the splits of a dataset';
    handles.config.log{end+1} = 'If splits contain independent datasets and components are congruent among the various splits, the model is validated';
    handles.config.log{end+1} = 'Splits are validated with the EEMlab''s ''splitvalidation011'' function';
    handles.config.log{end+1} = 'Models:Validations:Validate the splits ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Validations:Validate the splits';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Models:Validations:Validate the splits ...FAIL!'}];
end
guidata(hObject, handles);

% --------------------------------------------------------------------
function mdls_val_model_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newdata,err] = mdlsValModel(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    % APP config
    handles.data = newdata;
    % MENU config
    setMenu('on',handles.dset_norm_rvs,handles.plt_mdl);
    % GUI config
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Validations:Validate the model';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'Compare the Ex/Em spectra from PARAFAC models of the splits of a dataset';
    handles.config.log{end+1} = 'If splits contain independent datasets and components are congruent among the various splits, the model is validated';
    handles.config.log{end+1} = 'Splits are validated with the EEMlab''s ''splitvalidation011'' function';
    handles.config.log{end+1} = 'Models:Validations:Validate the model ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Models:Validations:Validate the model';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Models:Validations:Validate the model ...FAIL!'}];
end
guidata(hObject, handles);


%% PLOT functions

% --------------------------------------------------------------------
function plt_dset_2D_Callback(hObject, eventdata, handles)
if (strcmp(handles.plt_dset_2D.Checked,'off'))
    handles.plt_dset_2D.Checked = 'on';
    handles.plt_dset_3D.Checked = 'off';
    dim = '2D';
else
    handles.plt_dset_2D.Checked = 'off';
    handles.plt_dset_3D.Checked = 'on';
    dim = '3D';
end
pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
    handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
guidata(hObject, handles);

% --------------------------------------------------------------------
function plt_dset_3D_Callback(hObject, eventdata, handles)
if (strcmp(handles.plt_dset_3D.Checked,'off'))
    handles.plt_dset_2D.Checked = 'off';
    handles.plt_dset_3D.Checked = 'on';
    dim = '3D';
else
    handles.plt_dset_2D.Checked = 'on';
    handles.plt_dset_3D.Checked = 'off';
    dim = '2D';
end
pltDsetEem(handles.data,floor(handles.EEMlab_slider.Value),dim, ...
    handles.EEMlab_eem,handles.EEMlab_ex,handles.EEMlab_em);
guidata(hObject, handles);

% --------------------------------------------------------------------
function plt_dset_scans_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltDsetScans(handles.data,floor(handles.EEMlab_slider.Value));
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Dataset:Ex/Em scans';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Dataset:Ex/Em scans ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_dset_scatt_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltDsetScatt(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Dataset:Feature scattering';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Dataset:Feature scattering ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_dset_coll_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltDsetColl(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Dataset:Collection of samples';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Dataset:Collection of samples ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_speclod_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlSpecLod(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Spectral loadings';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Spectral loadings ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_cmpspec_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlCmpSpec(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Compare spectra';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Compare spectra ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_compcorr_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlCompCorr(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Component correlations';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Component correlations ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_lodlev_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlLodLev(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Loadings & leverages';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Loadings & leverages ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_eres1_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlEres1(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Error residuals';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Error residuals ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_eres2_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlEres2(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Error residuals';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Error residuals ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_specsse_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlSpecSse(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Spectral SSE';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Spectral SSE ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_ls_ssecc_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlLsSseCc(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Global SSE & core consistency';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Globall SSE & core consistency ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_fprints_Callback(hObject, eventdata, handles)
% Plots Sum of Squared Errors & Core Consistency of Least Squares Model
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlFprints(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Fingerprint';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Fingerprint ...FAIL!'}];
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function plt_mdl_mapcmp_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
err = pltMdlMapCmp(handles.data);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if ~isempty(err)
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Plot:Models:Map components';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Plot:Models:Map components ...FAIL!'}];
    guidata(hObject, handles);
end

%% HIDDEN functions

% --------------------------------------------------------------------
% === THIS MENU HAS SET TO VISIBLE=OFF in APPCONFIG script
% for this moment we do not consider any acquisition device offering raw
% EEMs and an specific spectral correction matrix for each sample
function lod_corr_spec_full_Callback(hObject, eventdata, handles)
handles.EEMlab_ok.Enable = 'off'; handles.EEMlab_nok.Enable = 'on'; 
[newloads,err] = lodCorrSpecFull(handles.data,handles.loads,handles.samplelog);
handles.EEMlab_ok.Enable = 'on'; handles.EEMlab_nok.Enable = 'off';
if isempty(err)
    handles.loads = newloads;
    setMenu('off',handles.lod_corr_spectral);
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Spectral corrections:EEM files';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log{end+1} = 'EM spectral correction files loaded';
    handles.config.log{end+1} = 'Load:Corrections:Spectral corrections:EEM files ...DONE!';
else
    handles.config.log{end+1} = ' ';
    handles.config.log{end+1} = '--> Load:Corrections:Spectral corrections:EEM files';
    handles.config.log{end+1} = ['Date: ' date];
    handles.config.log = [handles.config.log, ...
        err{:}, ...
        {'Load:Corrections:Spectral corrections:EEMfiles ...FAIL!'}];
end
guidata(hObject, handles);
