function varargout = lodConfFig(varargin)
% LODCONFFIG MATLAB code for lodConfFig.fig
%      LODCONFFIG, by itself, creates a new LODCONFFIG or raises the existing
%      singleton*.
%
%      H = LODCONFFIG returns the handle to a new LODCONFFIG or the handle to
%      the existing singleton*.
%
%      LODCONFFIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LODCONFFIG.M with the given input arguments.
%
%      LODCONFFIG('Property','Value',...) creates a new LODCONFFIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before lodConfFig_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to lodConfFig_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help lodConfFig

% Last Modified by GUIDE v2.5 10-Apr-2017 12:48:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @lodConfFig_OpeningFcn, ...
                   'gui_OutputFcn',  @lodConfFig_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before lodConfFig is made visible.
function lodConfFig_OpeningFcn(hObject, eventdata, handles, varargin)
set(hObject, 'Name','Experiment configuration')
% ERROR handling
if nargin ~= 4 % this counts for 'hObject', 'eventdata', 'handles' and 'varargin{1}
    % error
else
    loads = varargin{1};
end
% DEFAULT configuration (first time)
% The simplest correction method requires 6 inputs and 2 outputs to produce spectrally corrected EEMs in RU units 
% There are no inner filter correction, blank subtraction or QS calibration steps:
% [Xc Arp]=fdomcorrect(X,Ex,Em,Emcor,Excor,W);   %spectral correction in RU units with landa = 350 nm
if isempty(loads)
    loads.config.updated = '';  % if user SAVEs updated = true
                                % if user CLOSEs the figure without
                                % saving UPDATED = false
    % EEM files
    loads.config.tag.value = 0;
    loads.config.tag.enable = 'on';
    loads.config.eems.value = 0;
    loads.config.eems.enable = 'on';
    loads.config.meta.value = 1;
    loads.config.meta.enable = 'on';
    [~,fluornames] = enumeration('devFluorTags');
    loads.config.fluor.string = fluornames;
    loads.config.fluor.value = 1;
    loads.config.fluor.enable = 'on';
    loads.config.fluor.visible = 'off';
    % CORRECTIONS
    loads.config.Emcor.value = 0;
    loads.config.Emcor.enable = 'on';
    loads.config.Excor.value = 0;
    loads.config.Excor.enable = 'on';
    loads.config.B.value = 0;
    loads.config.B.enable = 'on';
    loads.config.dilfac.value = 0;
    loads.config.dilfac.enable = 'on';
    loads.config.A.value = 0;
    loads.config.A.enable = 'on';
    [~,spectnames] = enumeration('devSpectTags');
    loads.config.spect.string = spectnames;
    loads.config.spect.value = 1;
    loads.config.spect.enable = 'on';
    loads.config.spect.visible = 'off';
    % CALIBRATION
    loads.config.Q.value = 0;
    loads.config.Q.enable = 'on';
    % NORMALIZATION
    loads.config.landa.string = {'350','275',' '}; % excitation wavelength for Raman scans (normalize to RU275 or RU350)
    loads.config.landa.value = 1;
    loads.config.landa.enable = 'on';
    loads.config.landa.visible = 'on';
    loads.config.W.value = 1; % compulsory fdomcorrect input
    loads.config.W.enable = 'on';
    loads.config.T.value = 0; % Raman scans for blanks, if '0' T is automatically extracted from blanks
    loads.config.T.enable = 'on';
    loads.config.Qw.value = 0; % Raman scans for QS dilution series
    loads.config.Qw.enable = 'on';
    % TAG
    loads.config.tag.value = 0;
    loads.config.tag.enable = 'on';
    % reserve memory for files
    loads.Emcor = []; % Emission spectral corrections for ALL EEMs and scans
    loads.Excor = []; % Excitation spectral corrections for ALL EEMs and scans
    loads.A = []; % Absorbance scans
    loads.B = []; % Blank EEMs
    loads.dilfac = []; % Dilution factors
    loads.Q = []; % slope of QS dilution series
    loads.W = []; % EEM dataset water Raman scans
    loads.T = []; % Raman scans for blanks
    loads.Qw = []; % Raman scans for QS dilution series
%    loads.tag = [];	% experiment tags are directly stored in the DATA struct
                        % as they are needed for display INFO on each sample
end
% SET existent configuration
set(handles.eems, 'Value',loads.config.eems.value, 'Enable',loads.config.eems.enable);
set(handles.meta, 'Value',loads.config.meta.value, 'Enable',loads.config.meta.enable);
set(handles.fluor, 'String',loads.config.fluor.string, 'Value',loads.config.fluor.value, 'Enable',loads.config.fluor.enable, 'Visible',loads.config.fluor.visible);
set(handles.tag, 'Value',loads.config.tag.value, 'Enable',loads.config.tag.enable);
set(handles.Emcor, 'Value',loads.config.Emcor.value, 'Enable',loads.config.Emcor.enable);
set(handles.Excor, 'Value',loads.config.Excor.value, 'Enable',loads.config.Excor.enable);
set(handles.A, 'Value',loads.config.A.value, 'Enable',loads.config.A.enable);
set(handles.spect, 'String',loads.config.spect.string, 'Value',loads.config.spect.value, 'Enable',loads.config.spect.enable, 'Visible',loads.config.spect.visible);
set(handles.B, 'Value',loads.config.B.value, 'Enable',loads.config.B.enable);
set(handles.dilfac, 'Value',loads.config.dilfac.value, 'Enable',loads.config.dilfac.enable);
set(handles.Q, 'Value',loads.config.Q.value, 'Enable',loads.config.Q.enable);
set(handles.landa, 'String',loads.config.landa.string, 'Value',loads.config.landa.value, 'Enable',loads.config.landa.enable, 'Visible',loads.config.landa.visible);
set(handles.W, 'Value',loads.config.W.value, 'Enable',loads.config.W.enable);
set(handles.T, 'Value',loads.config.T.value, 'Enable',loads.config.T.enable);
set(handles.Qw, 'Value',loads.config.Qw.value, 'Enable',loads.config.Qw.enable);
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);
% UIWAIT makes lodConfFig wait for user response (see UIRESUME)
uiwait(handles.lodConfFig);


% --- Outputs from this function are returned to the command line.
function varargout = lodConfFig_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Get default command line output from handles structure
varargout{1} = handles.loads;
delete(handles.lodConfFig);

function eems_Callback(hObject, eventdata, handles)
% hObject    handle to current object
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject,'Value') == 1
    set(handles.tag, 'Value',0, 'Enable','on');
    set(handles.meta, 'Value',1, 'Enable','on');
    set(handles.fluor, 'Visible','on');
    set(handles.Emcor, 'Value',1, 'Enable','on');
    set(handles.Excor, 'Value',1, 'Enable','on');
    set(handles.B, 'Value',0, 'Enable','on');
    set(handles.dilfac, 'Value',0, 'Enable','on');
    set(handles.A, 'Value',0, 'Enable','on');
    set(handles.spect, 'Visible','off');
    set(handles.Q, 'Value',0, 'Enable','on');
    set(handles.landa, 'Value',1, 'Enable','on');
    set(handles.landa_label, 'Enable','on');
    set(handles.W, 'Value',1, 'Enable','on');
    set(handles.T, 'Value',0, 'Enable','on');
    set(handles.Qw, 'Value',0, 'Enable','on');
elseif get(hObject,'Value') == 0
    set(handles.tag, 'Value',0, 'Enable','off');
    set(handles.meta, 'Value',0, 'Enable','off');
    set(handles.fluor, 'Visible','off');
    set(handles.Emcor, 'Value',0, 'Enable','off');
    set(handles.Excor, 'Value',0, 'Enable','off');
    set(handles.B, 'Value',0, 'Enable','off');
    set(handles.dilfac, 'Value',0, 'Enable','off');
    set(handles.A, 'Value',0, 'Enable','off');
    set(handles.spect, 'Visible','off');
    set(handles.Q, 'Value',0, 'Enable','off');
    set(handles.landa, 'Value',3, 'Enable','off');
    set(handles.landa_label, 'Enable','off');
    set(handles.W, 'Value',0, 'Enable','off');
    set(handles.T, 'Value',0, 'Enable','off');
    set(handles.Qw, 'Value',0, 'Enable','off');
end
% update configuration changes
loads = handles.loads;
loads.config.tag.value = get(handles.tag, 'Value');
loads.config.tag.enable = get(handles.tag, 'Enable');
loads.config.eems.value = get(handles.eems, 'Value');
loads.config.eems.enable = get(handles.eems, 'Enable');
loads.config.meta.value = get(handles.meta, 'Value');
loads.config.meta.enable = get(handles.meta, 'Enable');
loads.config.fluor.visible = get(handles.fluor, 'Visible');
loads.config.Emcor.value = get(handles.Emcor, 'Value');
loads.config.Emcor.enable = get(handles.Emcor, 'Enable');
loads.config.Excor.value = get(handles.Excor, 'Value');
loads.config.Excor.enable = get(handles.Excor, 'Enable');
loads.config.B.value = get(handles.B, 'Value');
loads.config.B.enable = get(handles.B, 'Enable');
loads.config.dilfac.value = get(handles.dilfac, 'Value');
loads.config.dilfac.enable = get(handles.dilfac, 'Enable');
loads.config.A.value = get(handles.A, 'Value');
loads.config.A.enable = get(handles.A, 'Enable');
loads.config.spect.visible = get(handles.spect, 'Visible');
loads.config.Q.value = get(handles.Q, 'Value');
loads.config.Q.enable = get(handles.Q, 'Enable');
loads.config.landa.value = get(handles.landa, 'Value');
loads.config.landa.enable = get(handles.landa, 'Enable');
loads.config.W.value = get(handles.W, 'Value');
loads.config.W.enable = get(handles.W, 'Enable');
loads.config.T.value = get(handles.T, 'Value');
loads.config.T.enable = get(handles.T, 'Enable');
loads.config.Qw.value = get(handles.Qw, 'Value');
loads.config.Qw.enable = get(handles.Qw, 'Enable');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function meta_Callback(hObject, eventdata, handles)
% hObject    handle to meta (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% save configuration changes
loads = handles.loads;
loads.config.meta.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function fluor_CreateFcn(hObject, eventdata, handles)
% hObject    handle to current object (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function fluor_Callback(hObject, eventdata, handles)
% hObject    handle to current object (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
loads = handles.loads;
loads.config.fluor.value = get(handles.fluor, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function Emcor_Callback(hObject, eventdata, handles)
% hObject    handle to current object (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% save configuration changes
loads = handles.loads;
loads.config.Emcor.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function Excor_Callback(hObject, eventdata, handles)
% hObject    handle to current object (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
loads = handles.loads;
loads.config.Excor.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function B_Callback(hObject, eventdata, handles)
% hObject    handle to B (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if get(hObject,'Value') == 0
    set(handles.T, 'Value',0);
end
loads = handles.loads;
loads.config.B.value = get(hObject, 'Value');
loads.config.T.value = get(handles.T, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function dilfac_Callback(hObject, eventdata, handles)
% hObject    handle to dilfac (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
loads = handles.loads;
loads.config.dilfac.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


% --- Executes on button press in A.
function A_Callback(hObject, eventdata, handles)
% hObject    handle to A (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Component behaviour
if get(hObject,'Value') == 1
    set(handles.spect, 'Value',1);
    set(handles.spect, 'Visible','on');
elseif get(hObject,'Value') == 0
    set(handles.spect, 'Value',1);
    set(handles.spect, 'Visible','off');
end
loads = handles.loads;
loads.config.A.value = get(hObject, 'Value');
loads.config.spect.value = get(hObject, 'Value');
loads.config.spect.visible = get(hObject, 'Visible');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function spect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to spect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function spect_Callback(hObject, eventdata, handles)
% hObject    handle to spect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
loads = handles.loads;
loads.config.spect.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function Q_Callback(hObject, eventdata, handles)
% hObject    handle to Q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Component behaviour
if get(hObject,'Value') == 1
    set(handles.Qw, 'Value',1);
elseif get(hObject,'Value') == 0
    set(handles.Qw, 'Value',0);
end
loads = handles.loads;
loads.config.Q.value = get(hObject, 'Value');
loads.config.Qw.value = get(handles.Qw, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function landa_CreateFcn(hObject, eventdata, handles)
% hObject    handle to landa (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function landa_Callback(hObject, eventdata, handles)
% hObject    handle to landa (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
loads = handles.loads;
loads.config.landa.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function W_Callback(hObject, eventdata, handles)
% hObject    handle to W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
loads = handles.loads;
loads.config.W.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function T_Callback(hObject, eventdata, handles)
% hObject    handle to W (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Component behaviour
if get(hObject,'Value') == 1
    set(handles.B, 'Value',1);
end
loads = handles.loads;
loads.config.T.value = get(hObject, 'Value');
loads.config.B.value = get(handles.B, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function Qw_Callback(hObject, eventdata, handles)
% hObject    handle to Q (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Component behaviour
if get(hObject,'Value') == 1
    set(handles.Q, 'Value',1);
elseif get(hObject,'Value') == 0
    set(handles.Q, 'Value',0);
end
loads = handles.loads;
loads.config.Qw.value = get(hObject, 'Value');
loads.config.Q.value = get(handles.Q, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.loads.config.updated = true;
guidata(hObject, handles);
uiresume(gcbf);


% --- Executes on button press in tag.
function tag_Callback(hObject, eventdata, handles)
% hObject    handle to tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Component behaviour
if get(hObject,'Value') == 1
    set(handles.tag, 'Value',1);
elseif get(hObject,'Value') == 0
    set(handles.tag, 'Value',0);
end
loads = handles.loads;
loads.config.tag.value = get(hObject, 'Value');
% Update handles structure
handles.loads = loads;
guidata(hObject, handles);


% --- Executes when user attempts to close lodConfFig.
function lodConfFig_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to lodConfFig (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.loads.config.updated = false;
guidata(hObject, handles);
uiresume(gcbf);


% --- Executes on button press in cancel.
function cancel_Callback(hObject, eventdata, handles)
% hObject    handle to cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.loads.config.updated = false;
guidata(hObject, handles);
uiresume(gcbf);
