function varargout = mdlsExplFig(varargin)
% MDLSEXPLFIG MATLAB code for mdlsExplFig.fig
%      MDLSEXPLFIG, by itself, creates a new MDLSEXPLFIG or raises the existing
%      singleton*.
%
%      H = MDLSEXPLFIG returns the handle to a new MDLSEXPLFIG or the handle to
%      the existing singleton*.
%
%      MDLSEXPLFIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MDLSEXPLFIG.M with the given input arguments.
%
%      MDLSEXPLFIG('Property','Value',...) creates a new MDLSEXPLFIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mdlsExplFig_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mdlsExplFig_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mdlsExplFig

% Last Modified by GUIDE v2.5 22-Mar-2017 10:32:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mdlsExplFig_OpeningFcn, ...
                   'gui_OutputFcn',  @mdlsExplFig_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mdlsExplFig is made visible.
function mdlsExplFig_OpeningFcn(hObject, eventdata, handles, varargin)
set(hObject, 'Name','Exploratory analysis')
% load of values
% ... see figure properties with the GUIDE tool

% Update handles structure with DEFAULT values
% variable WAVESTEP
contents = cellstr(get(handles.wavestep,'String'));
value = contents{get(handles.wavestep,'Value')};
switch value,
    case 'use all the data',
        user_info.wavestep = [1 1];
    case 'use every other Em wavelength',
        user_info.wavestep = [1 2];
    case 'use every other Ex and Em wavelengt',
        user_info.wavestep = [2 2];
end

% variable MYFACTORS
contents = get(handles.myfactors,'String');
myfactors = [];
while ~isempty(contents)
    [token, remain] = strtok(contents,',');
    myfactors = [myfactors str2double(strtrim(token))];
    contents = remain;
end
user_info.myfactors = myfactors;

% variable CONSTRAINTS
contents = cellstr(get(handles.constraints,'String'));
value = contents{get(handles.constraints,'Value')};
switch value,
    case 'non-negativity',
        user_info.constraints = 'nonnegativity';
    case 'unconstrained',
        user_info.constraints = 'unconstrained';
end

% variable CC (convergence criterion)
user_info.CC = str2double(strtrim(get(handles.CC,'String')));

% variable STEPWISE
contents = cellstr(get(handles.stepwise,'String'));
value = contents{get(handles.stepwise,'Value')};
switch value,
    case 'run one model at a time',
        user_info.stepwise = 'stepwise';
    case 'run models at once',
        user_info.stepwise = 'at once';
end

% Update handles structure
handles.user_info = user_info;
guidata(hObject, handles);

% UIWAIT makes mdlsExplFig wait for user response (see UIRESUME)
uiwait(handles.mdlsExplFig);


% --- Outputs from this function are returned to the command line.
function varargout = mdlsExplFig_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
varargout{1} = handles.user_info;
delete(handles.mdlsExplFig);


% --- Executes on selection change in wavestep.
function wavestep_Callback(hObject, eventdata, handles)
% hObject    handle to wavestep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
value = contents{get(hObject,'Value')};
switch value,
    case 'use all the data',
        wavestep = [1 1];
    case 'use every other Em wavelength',
        wavestep = [1 2];
    case 'use every other Ex and Em wavelengt',
        wavestep = [2 2];
end
handles.user_info.wavestep = wavestep;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function wavestep_CreateFcn(hObject, eventdata, handles)
% hObject    handle to wavestep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in constraints.
function constraints_Callback(hObject, eventdata, handles)
% hObject    handle to constraints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
value = contents{get(hObject,'Value')};
switch value,
    case 'non-negativity',
        constraints = 'nonnegativity';
    case 'unconstrained',
        constraints = 'unconstrained';
end
handles.user_info.constraints = constraints;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function constraints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to constraints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function myfactors_Callback(hObject, eventdata, handles)
% hObject    handle to myfactors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = get(hObject,'String');
myfactors = [];
while ~isempty(contents)
    [token, remain] = strtok(contents,',');
    myfactors = [myfactors str2double(strtrim(token))];
    contents = remain;
end
handles.user_info.myfactors = myfactors;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function myfactors_CreateFcn(hObject, eventdata, handles)
% hObject    handle to myfactors (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function CC_Callback(hObject, eventdata, handles)
% hObject    handle to CC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
user_info.CC = str2double(strtrim(get(hObject,'String')));


% --- Executes during object creation, after setting all properties.
function CC_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in stepwise.
function stepwise_Callback(hObject, eventdata, handles)
% hObject    handle to stepwise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
value = contents{get(hObject,'Value')};
switch value,
    case 'run one model at a time',
        stepwise = 'stepwise';
    case 'run models at once',
        stepwise = 'at once';
end
handles.user_info.stepwise = stepwise;
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function stepwise_CreateFcn(hObject, eventdata, handles)
% hObject    handle to stepwise (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in run.
function run_Callback(hObject, eventdata, handles)
% hObject    handle to run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiresume(gcbf);

% --- Executes on button press in cancel.
function cancel_Callback(hObject, eventdata, handles)
% hObject    handle to cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.user_info = [];
guidata(hObject, handles);
uiresume(gcbf);
