function varargout = mdlsRefFig(varargin)
% MDLSREF MATLAB code for mdlsRef.fig
%      MDLSREF, by itself, creates a new MDLSREF or raises the existing
%      singleton*.
%
%      H = MDLSREF returns the handle to a new MDLSREF or the handle to
%      the existing singleton*.
%
%      MDLSREF('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MDLSREF.M with the given input arguments.
%
%      MDLSREF('Property','Value',...) creates a new MDLSREF or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mdlsRefFig_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mdlsRefFig_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mdlsRef

% Last Modified by GUIDE v2.5 10-Apr-2017 09:03:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mdlsRefFig_OpeningFcn, ...
                   'gui_OutputFcn',  @mdlsRefFig_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mdlsRef is made visible.
function mdlsRefFig_OpeningFcn(hObject, eventdata, handles, varargin)
set(hObject, 'Name','Refine models')
% load of values
% ... see figure properties with the GUIDE tool
if nargin == 4
    data = varargin{1};
end

% variable EXMODEL (select an exporatory model)
models = sort(data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'exploratory'))));
% Selection of the model prepared to validate
% models = [data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'- VALID'))); ...
%     data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'- NOT VALID'))); ...
%     data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'- to validate')))];
handles.exmodel.String = models;
user_info.smodel = models{1};
tok = strtok(user_info.smodel,'Model');
% variable F
user_info.f = str2double(tok(1));
handles.f.String = user_info.f;

% variable IT
user_info.it = str2double(strtrim(get(handles.it,'String')));
% variable CONSTRAINTS
contents = cellstr(get(handles.constraints,'String'));
value = contents{get(handles.constraints,'Value')};
switch value,
    case 'non-negativity',
        user_info.constraints = 'nonnegativity';
    case 'unconstrained',
        user_info.constraints = 'unconstrained';
end

% variable CONVCRIT (convergence criterion)
user_info.convgcrit = str2double(strtrim(get(handles.convgcrit,'String')));

% Update handles structure
handles.user_info = user_info;
guidata(hObject, handles);
% UIWAIT makes mdlsReflFig wait for user response (see UIRESUME)
uiwait(handles.mdlsRef);


% --- Outputs from this function are returned to the command line.
function varargout = mdlsRefFig_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
varargout{1} = handles.user_info;
delete(handles.mdlsRef);


% --- Executes on selection change in constraints.
function constraints_Callback(hObject, eventdata, handles)
% hObject    handle to constraints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
value = contents{get(hObject,'Value')};
switch value,
    case 'non-negativity',
        constraints = 'nonnegativity';
    case 'unconstrained',
        constraints = 'unconstrained';
end
handles.user_info.constraints = constraints;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function constraints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to constraints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function f_Callback(hObject, eventdata, handles)
% hObject    handle to f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.user_info.f = str2double(strtrim(get(hObject,'String')));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function f_CreateFcn(hObject, eventdata, handles)
% hObject    handle to f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function convgcrit_Callback(hObject, eventdata, handles)
% hObject    handle to convgcrit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.user_info.convgcrit = str2double(strtrim(get(hObject,'String')));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function convgcrit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to convgcrit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in run.
function run_Callback(hObject, eventdata, handles)
% hObject    handle to run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiresume(gcbf);

% --- Executes on button press in cancel.
function cancel_Callback(hObject, eventdata, handles)
% hObject    handle to cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.user_info = [];
guidata(hObject, handles);
uiresume(gcbf);

function it_Callback(hObject, eventdata, handles)
% hObject    handle to it (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.user_info.it = str2double(strtrim(get(hObject,'String')));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function it_CreateFcn(hObject, eventdata, handles)
% hObject    handle to it (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in exmodel.
function exmodel_Callback(hObject, eventdata, handles)
% hObject    handle to exmodel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
handles.user_info.smodel = contents{get(hObject,'Value')};
tok = strtok(handles.user_info.smodel,'Model');
handles.user_info.f = str2double(tok(1));
handles.f.String = handles.user_info.f;
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function exmodel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to exmodel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
