function varargout = mdlsShaFig(varargin)
% MDLSSHAFIG MATLAB code for mdlsShaFig.fig
%      MDLSSHAFIG, by itself, creates a new MDLSSHAFIG or raises the existing
%      singleton*.
%
%      H = MDLSSHAFIG returns the handle to a new MDLSSHAFIG or the handle to
%      the existing singleton*.
%
%      MDLSSHAFIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MDLSSHAFIG.M with the given input arguments.
%
%      MDLSSHAFIG('Property','Value',...) creates a new MDLSSHAFIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mdlsShaFig_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mdlsShaFig_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mdlsShaFig

% Last Modified by GUIDE v2.5 19-Apr-2017 18:17:32

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mdlsShaFig_OpeningFcn, ...
                   'gui_OutputFcn',  @mdlsShaFig_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mdlsShaFig is made visible.
function mdlsShaFig_OpeningFcn(hObject, eventdata, handles, varargin)
set(hObject, 'Name','Model the splits')
% load of values
% ... see figure properties with the GUIDE tool
if nargin == 4
    data = varargin{1};
end

% Update handles structure with DEFAULT values
handles.names = [{'A'},{'B'},{'C'},{'D'},{'E'},{'F'},{'G'},{'H'},{'I'}, ...
    {'J'},{'K'},{'L'},{'M'},{'N'},{'O'},{'P'},{'Q'},{'R'},{'S'},{'T'},{'U'}, ...
    {'V'},{'W'},{'X'},{'Y'},{'Z'}];

% variable F (taken for the list of already REFINED models)
%models = data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'refined')));
% Selection of the model prepared to validate
models = [data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'exploratory'))); ...
    data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'refined')))];
ncomp = cell(1,length(models));
for i = 1 : length(models)
    tok = strtok(models{i},'Model');
    ncomp{i} = tok(1);
end
ncomp = unique(ncomp);
handles.f.String = ncomp;
user_info.f = str2double(ncomp{1});

% variable CONSTRAINTS
contents = cellstr(get(handles.constraints,'String'));
value = contents{get(handles.constraints,'Value')};
switch value,
    case 'non-negativity',
        user_info.constraints = 'nonnegativity';
    case 'no constraints',
        user_info.constraints = 'no constraints';
end

% variable CCOMP
values = '';
splitnames = cell(1,data.Split_NumAfterCombine);
for i = 1 : data.Split_NumAfterCombine
    splitnames{i} = strjoin(handles.names(str2num(data.Split_Combinations{i})));
    values = [values '[' splitnames{i},'], ']; 
end
ind = strfind(values,',');
str = values(1,1:ind(end)-1);
handles.ccomp.String = str;

% variable RUNS
handles.runs.String = repmat('[3] ',1,data.Split_NumAfterCombine);
contents = textscan(get(handles.runs,'String'),'[%u]');
runs = contents{:}';
user_info.runs = runs;

% variable CC (convergence criterion)
handles.cc.String = repmat('[1e-6] ',1,data.Split_NumAfterCombine);
contents = textscan(get(handles.cc,'String'),'[%f]');
cc = contents{:}';
user_info.cc = cc;

% Update handles structure
handles.user_info = user_info;
guidata(hObject, handles);

% UIWAIT makes mdlsShaFig wait for user response (see UIRESUME)
uiwait(handles.mdlsShaFig);


% --- Outputs from this function are returned to the command line.
function varargout = mdlsShaFig_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
varargout{1} = handles.user_info;
delete(handles.mdlsShaFig);

% --- Executes on button press in run.
function run_Callback(hObject, eventdata, handles)
% hObject    handle to run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiresume(gcbf);

% --- Executes on button press in cancel.
function cancel_Callback(hObject, eventdata, handles)
% hObject    handle to cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.user_info = [];
guidata(hObject, handles);
uiresume(gcbf);


% --- Executes on selection change in constraints.
function constraints_Callback(hObject, eventdata, handles)
% hObject    handle to constraints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
value = contents{get(hObject,'Value')};
switch value,
    case 'non-negativity',
        constraints = 'nonnegativity';
    case 'no constraints',
        constraints = 'no constraints';
end
handles.user_info.constraints = constraints;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function constraints_CreateFcn(hObject, eventdata, handles)
% hObject    handle to constraints (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function runs_Callback(hObject, eventdata, handles)
% hObject    handle to runs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = textscan(get(hObject,'String'),'[%u]');
runs = contents{:}';
handles.user_info.runs = runs;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function runs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to runs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function cc_Callback(hObject, eventdata, handles)
% hObject    handle to cc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = textscan(get(hObject,'String'),'[%f]');
cc = contents{:}';
handles.user_info.cc = cc;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function cc_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cc (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function ccomp_Callback(hObject, eventdata, handles)
% hObject    handle to ccomp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ccomp as text
%        str2double(get(hObject,'String')) returns contents of ccomp as a double


% --- Executes during object creation, after setting all properties.
function ccomp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ccomp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in f.
function f_Callback(hObject, eventdata, handles)
% hObject    handle to f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
handles.user_info.f = str2double(contents{get(hObject,'Value')});
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function f_CreateFcn(hObject, eventdata, handles)
% hObject    handle to f (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
