function varargout = mdlsValSplitsFig(varargin)
% MDLSVALSPLITSFIG MATLAB code for mdlsValSplitsFig.fig
%      MDLSVALSPLITSFIG, by itself, creates a new MDLSVALSPLITSFIG or raises the existing
%      singleton*.
%
%      H = MDLSVALSPLITSFIG returns the handle to a new MDLSVALSPLITSFIG or the handle to
%      the existing singleton*.
%
%      MDLSVALSPLITSFIG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MDLSVALSPLITSFIG.M with the given input arguments.
%
%      MDLSVALSPLITSFIG('Property','Value',...) creates a new MDLSVALSPLITSFIG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mdlsValSplitsFig_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mdlsValSplitsFig_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mdlsValSplitsFig

% Last Modified by GUIDE v2.5 16-Oct-2017 13:27:41

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @mdlsValSplitsFig_OpeningFcn, ...
                   'gui_OutputFcn',  @mdlsValSplitsFig_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mdlsValSplitsFig is made visible.
function mdlsValSplitsFig_OpeningFcn(hObject, eventdata, handles, varargin)
set(hObject, 'Name','Validation of dataset splits')
% load of values
% ... see figure properties with the GUIDE tool
if nargin == 4
    data = varargin{1};
end

% Update handles structure with DEFAULT values
handles.names = [{'A'},{'B'},{'C'},{'D'},{'E'},{'F'},{'G'},{'H'},{'I'}, ...
    {'J'},{'K'},{'L'},{'M'},{'N'},{'O'},{'P'},{'Q'},{'R'},{'S'},{'T'},{'U'}, ...
    {'V'},{'W'},{'X'},{'Y'},{'Z'}];

% variable NUMSPLIT
handles.numsplit.String = num2str(data.Split_NumBeforeCombine);

% variable SNAME
values = handles.names(1:data.Split_NumBeforeCombine);
cl = cell(1,data.Split_NumBeforeCombine-1);
cl(:) = {'], ['};
str = ['[' strjoin(values,cl) ']'];
str = strrep(str,'  ',' ');
handles.sname.String = str;

% variable SAMPXSPLIT
handles.sampxsplit.String = num2str(data.Split_nSample);

% variable NUMCOMB
handles.numcomb.String = num2str(data.Split_NumAfterCombine);

% variable CCOMP
values = '';
splitnames = cell(1,data.Split_NumAfterCombine);
for i = 1 : data.Split_NumAfterCombine
    splitnames{i} = strjoin(handles.names(str2num(data.Split_Combinations{i})));
    values = [values '[' splitnames{i},'], ']; 
end
ind = strfind(values,',');
str = values(1,1:ind(end)-1);
handles.ccomp.String = str;
user_info.splitnames = splitnames;

% variable CNAME
values = cellstr(num2str((1:data.Split_NumAfterCombine)'))';
cl = cell(1,data.Split_NumAfterCombine-1);
cl(:) = {'], ['};
str = ['[' strjoin(values,cl) ']'];
str = strrep(str,'  ',' ');
handles.cname.String = str;

% variable COMPARISONS
contents = textscan(get(handles.comparisons,'String'),'[%u %u],');
comparisons = double([contents{1} contents{2}]);
user_info.comparisons = comparisons;

% variable OVERALL (no exploratory models included)
% models = sort([data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'- VALID'))); ...
%     data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'- NOT VALID'))); ...
%     data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'- to validate')))]);
models = sort(data.modelNames(~cellfun(@isempty,strfind(data.modelNames,'splitted'))));
handles.overall.String = models;
user_info.smodel = models{1};
tok = strtok(user_info.smodel,'Model');
user_info.f = str2double(tok(1));
if strfind(user_info.smodel,'refined')
    user_info.overall = ['Model' num2str(user_info.f)];
elseif strfind(user_info.smodel,'splitted')
    user_info.overall = [];
end

% variable P (Tucker correlation coefficient, the criterion for spectral match)
p = 0.95; % default and fixed p value from drEEM's SPLITVALIDATION function
handles.p.String = num2str(p);
user_info.p = p;

% Update handles structure
handles.user_info = user_info;
guidata(hObject, handles);

% UIWAIT makes mdlsValSplitsFig wait for user response (see UIRESUME)
uiwait(handles.mdlsValSplitsFig);


% --- Outputs from this function are returned to the command line.
function varargout = mdlsValSplitsFig_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
varargout{1} = handles.user_info;
delete(handles.mdlsValSplitsFig);


% --- Executes on selection change in overall2.
function overall_Callback(hObject, eventdata, handles)
% hObject    handle to overall2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
contents = cellstr(get(hObject,'String'));
handles.user_info.smodel = contents{get(hObject,'Value')};
tok = strtok(handles.user_info.smodel,'Model');
handles.user_info.f = str2double(tok(1));
if strfind(handles.user_info.smodel,'refined')
    handles.user_info.overall = ['Model' num2str(handles.user_info.f)];
elseif strfind(handles.user_info.smodel,'splitted')
    handles.user_info.overall = [];
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function overall_CreateFcn(hObject, eventdata, handles)
% hObject    handle to overall2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function comparisons_Callback(hObject, eventdata, handles)
% hObject    handle to comparisons (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
string = textscan(get(hObject,'String'),'[%u %u],');
splits = [string{1} string{2}];
comparisons = num2cell(splits,2)';
handles.user_info.comparisons = comparisons;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function comparisons_CreateFcn(hObject, eventdata, handles)
% hObject    handle to comparisons (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in run.
function run_Callback(hObject, eventdata, handles)
% hObject    handle to run (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
uiresume(gcbf);

% --- Executes on button press in cancel.
function cancel_Callback(hObject, eventdata, handles)
% hObject    handle to cancel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
handles.user_info = [];
guidata(hObject, handles);
uiresume(gcbf);



function numcomb_Callback(hObject, eventdata, handles)
% hObject    handle to numcomb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numcomb as text
%        str2double(get(hObject,'String')) returns contents of numcomb as a double


% --- Executes during object creation, after setting all properties.
function numcomb_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numcomb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function numsplit_Callback(hObject, eventdata, handles)
% hObject    handle to numsplit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numsplit as text
%        str2double(get(hObject,'String')) returns contents of numsplit as a double


% --- Executes during object creation, after setting all properties.
function numsplit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numsplit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function ccomp_Callback(hObject, eventdata, handles)
% hObject    handle to ccomp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of ccomp as text
%        str2double(get(hObject,'String')) returns contents of ccomp as a double


% --- Executes during object creation, after setting all properties.
function ccomp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to ccomp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function sname_Callback(hObject, eventdata, handles)
% hObject    handle to sname (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sname as text
%        str2double(get(hObject,'String')) returns contents of sname as a double


% --- Executes during object creation, after setting all properties.
function sname_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sname (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function sampxsplit_Callback(hObject, eventdata, handles)
% hObject    handle to sampxsplit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of sampxsplit as text
%        str2double(get(hObject,'String')) returns contents of sampxsplit as a double


% --- Executes during object creation, after setting all properties.
function sampxsplit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to sampxsplit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function cname_Callback(hObject, eventdata, handles)
% hObject    handle to cname (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cname as text
%        str2double(get(hObject,'String')) returns contents of cname as a double


% --- Executes during object creation, after setting all properties.
function cname_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cname (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function p_Callback(hObject, eventdata, handles)
% hObject    handle to p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

p = str2double(get(hObject,'String'));
handles.user_info.p = p;
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function p_CreateFcn(hObject, eventdata, handles)
% hObject    handle to p (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
