function [ newdata, error ] = dsetResize( data )
%
%PRERESIZE clips EEMs to the defined Region Of Interest (ROI)
% It uses the drEEM's SUBDATASET script

%% === INIT
newdata = data;
error = {};

%% === INFO
% label = 'Resize';
% info = strcat({ ...
%     'All the spectrums will be resized to the new ROI', ...
%     });
% uiwait(msgbox(info,label,'modal'));

%% === DATA LOAD
dlg_title = 'Resize';
prompt = { ...
    'Excitation ROI (nm):', ...
    'Emission ROI (nm):', ...
    };
num_lines = 1;
def = { ...
    ['[' num2str(min(data.Ex)) ' ' num2str(max(data.Ex)) ']'], ...
    ['[' num2str(min(data.Em)) ' ' num2str(max(data.Em)) ']'], ...
    };
user_info = inputdlg(prompt,dlg_title,num_lines,def);
if isempty(user_info)
    error = [error, {'ERROR: EEMlab:dsetResize:userSelectedCancel'}];
    return;
else
    [token, remain] = strtok(user_info{1});
    ex_start = str2double(token(2:end));
    ex_end = str2double(remain(1:end-1));
    [token, remain] = strtok(user_info{2});
    em_start = str2double(token(2:end));
    em_end = str2double(remain(1:end-1));
end

%% === UPDATE DATASET
outSample = [];
outEm = (data.Em < em_start) | (em_end < data.Em);
outEx = (data.Ex < ex_start) | (ex_end < data.Ex);
newdata = subdataset(data,outSample,outEm,outEx);

end