function [ newdata, error ] = dsetRmOutByComp( data )
%
%PRERMOUTLIERS removes the selected samples (outliers) from the data
% structure. 
% It uses the drEEM's SUBDATASET script

%% === INIT
newdata = data;
error = {};

%% === INFO
label = 'Remove outliers';
info = strcat({ ...
    'This removes the selected outliers from the data structure', ...
    'This processing uses the drEEM''s SUBDATASET script', ...
    'SUBDATASET subsets a dataset by removing samples and/or wavelengths', ...
    'Type HELP SUBDATASET in MATLAB''s console for more info', ...
    });
uiwait(msgbox(info,label,'modal'));

%% === DATA LOAD
slist = num2str((1:data.nSample)'); % list of samples
[outSample,ok] = listdlg('Name','Remove outliers',...
    'PromptString','Observations to remove:',...
    'SelectionMode','multiple',...
    'ListSize',[160 250],...
    'ListString',slist);
if ~ok
    error = [error, {'ERROR: EEMlab:dsetRmOutByComp:userSelectedCancel'}];
    return;
end

%% === UPDATE DATASET
outEm = [];
outEx = [];
newdata = subdataset(data,outSample,outEm,outEx);

end