function [ newloads, info ] = lodConf( loads )
%LODCONFIG defines the configuration for the loads and FDOM corrections

%% === INIT
info = {};

%% === DATA LOAD
newloads = lodConfFig(loads);

%% === INFO
info = [info, ...
    {'ACQUISITION', ...
    ['EEM files: ' num2str(newloads.config.eems.value)], ...
    ['Metadata file: ' num2str(newloads.config.meta.value)], ...
    ['Tags & labels: ' num2str(newloads.config.tag.value)], ...
    'CORRECTIONS', ...
    ['Emission spectrum: ' num2str(newloads.config.Emcor.value)], ...
    ['Excitation spectrum: ' num2str(newloads.config.Excor.value)], ...
    ['Blank subtraction: ' num2str(newloads.config.B.value)], ...
    ['Dilution factors: ' num2str(newloads.config.dilfac.value)], ...
    ['Inner Filter Effect: ' num2str(newloads.config.A.value)], ...
    'QS CALIBRATION', ...
    ['QS dilution series slope: ' num2str(newloads.config.Q.value)], ...
    'RAMAN NORMALIZATION', ...
    ['Excitation wavelength (nm): ' newloads.config.landa.string{newloads.config.landa.value}], ...
    ['Dataset water Raman scans: ' num2str(newloads.config.W.value)], ...
    ['Water Raman scans for blanks: ' num2str(newloads.config.T.value)], ...
    ['Water Raman scans for QS: ' num2str(newloads.config.Qw.value)], ...
    }];
if (newloads.config.eems.value == 1) || (newloads.config.A.value == 1)
    info = [info, ...
        {'DEVICES'}];
    if (newloads.config.eems.value == 1)
        info = [info, ...
            {['Fluorometer: ' newloads.config.fluor.string{newloads.config.fluor.value}]}];
    else
        newloads.config.fluor.value = 0;
        newloads.config.fluor.visible = 'off';
    end
    if (newloads.config.A.value == 1)
        info = [info, ...
            {['Spectrophotometer: ' newloads.config.spect.string{newloads.config.spect.value}]}];
    else
        newloads.config.spect.value = 0;
        newloads.config.spect.visible = 'off';
    end
end

%% === UPDATE DATASET

end