function [ newsamplelog, datadir, error ] = lodDsetMeta( samplelog )
%LODDSETMETA loads metainformation in dataset(samplelog file)

%% === INIT
newsamplelog = samplelog;
datadir = '';
error = {};

%% === INFO

%% === ERROR CHECKING

%% === DATA LOAD
title = 'Select the metadata samplelog file';
filterspec = { ...
    '*.xls;*.xlsx','Excel metadata file'; ...
    '*.csv','CSV metadata file'; ...
    };
[filename, pathname, filterindex] = uigetfile(filterspec,title, 'MultiSelect','off');
switch filterindex
    case 0
        error = [error, {'ERROR: EEMlab:lodDsetEems:userSelectedCancel'}];
        return;
    case 1
        % XLSX metadata file (a 'SampleLog' file from EEMlab toolbox)
        [data,err] = readxlslogfile(strcat(pathname,filename));
        if isempty(err)
        else
            error = [error err{:}];
            return;
        end
    case 2
        % CSV metadata file (a 'SampleLog' file from drEEM toolbox)
        [strings,err] = getlogtypes(strcat(pathname,filename));
        if isempty(err)
            [data,~,~] = readlogfile(strcat(pathname,filename),strings);
        else
            error = [error err{:}];
            return;
        end
end

%% === UPDATE DATASET
newsamplelog = data;
datadir = pathname;

end