function [ error ] = mdlsList( data )
%

%% === INIT
error = {};

%% === ERROR CHECKING
if ~isfield(data,'modelNames') || isempty(data.modelNames)
    info = strcat({ ...
        'The dataset has not been still modeled', ...
        'Please create an exploratory or refined model first', ...
        });
    label = 'Error';
    icon = 'error';
    uiwait(msgbox(info,label,icon,'modal'));
    error = [error, {'ERROR: EEMlab:mdlsList:noModelsToProcess'}];
    return;
end

%% === INFO
label = 'List of models';
models = data.modelNames;
info = strcat(sort({ ...
                models{:}, ...
                }));
uiwait(msgbox(info,label,'modal'));

%% === DATA LOAD

%% === PLOTS

%% === UPDATE DATASET

end