function [ error ] = pltDsetScans( data, sample )
%

%% === INIT
error = {};

%% === INFO
label = 'Ex/Em scans';
info = strcat({ ...
    'Plots EEM scans for the maximum intensity value', ...
    });
uiwait(msgbox(info,label,'modal'));

%% === DATA LOAD
emAxe = data.Em; % rows
exAxe = data.Ex; % cols
intValues = reshape(data.X(sample,:,:),[data.nEm data.nEx]);
intUnits = data.IntensityUnit;

% selecting point to the MAX intensity value
[ex,em,~,err] = getFeature(exAxe,emAxe,intValues,'maximum');
if isempty(err)
    spoint = [ex em];   % SPOINT(1) is the excitation wavelength for the selected point
else                    % SPOINT(2) is the emission wavelength for the selected point
    error = [error, err];
end

%% === PLOT
[~,err] = plotScans(exAxe,emAxe,intValues,intUnits,spoint);
error = [error, err];

end