function dispInfo( samp, nSamp, tagNames, tagValues, feaNames, feaValues, feaUnits, hdl )
%
% DISPINFO displays the information of the selected sample
% SAMP:         number of sample from the total samples in the experiment
% NSAMP:        total number of samples in the experiment
% TAGNAMES:     the name of the tags to be displayed
% TAGVALUES:    the value of the tags TAGNAMES for the sample SAMP
% FEANAMES:     the name of the features to be displayed
% FEAVALUES:    the value of the features FEANAMES for the sample SAMP
% FEAUNITS:     the units of the features FEANAMES for the sample SAMP
% HDL:          selected text handles to plot in

%% === INIT
info = cell(length(tagNames)+length(feaNames)+4,1);

%% === PLOT
% getting 'string' feature values
feaValues = cellfun(@num2str,cell(feaValues),'UniformOutput',false);

info{1} = 'INFORMATION';
info{2} = ['Observation: ' num2str(samp) '/' num2str(nSamp)];
if ~isempty(tagNames) && (length(tagNames) == length(tagValues))
    j = 1;
    for i = 3 : length(tagNames)+2
        info{i} = [tagNames{j} ': ' tagValues{j}];
        j = j + 1;
    end
end

info{length(tagNames)+3} = '';
info{length(tagNames)+4} = 'FEATURES';
if ~isempty(feaNames) && (length(feaNames) == length(feaValues)) ...
        && (length(feaNames) == length(feaUnits))
    j = 1;
    for i = length(tagNames)+5 : length(tagNames)+length(feaNames)+4
        info{i} = [feaNames{j} ': ' feaValues{j} ' ' feaUnits{j}];
        j = j + 1;
    end
end

hdl.String = info;

end