function setMenu(action, varargin)

switch action,
    case 'on', openmn(varargin);
    case 'off', closemn(varargin);
end

% sub-functions in HERE!
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    function openmn(varargin)
        %OPENMN enables the menus and (3 levels of) sub-menus passed as handles
        %detailed in the list of handles in VARARGIN
        %
        varargin = varargin{:};
        nargin = length(varargin);
        for item = 1 : nargin
            menu_handle = varargin{item};
            % we open menu handle
            set(menu_handle, 'Enable','on', 'ForegroundColor','k');
            % we open all Parent menus
            parent = get(menu_handle,'Parent');
            while ~isa(parent,'matlab.ui.Figure')
                set(parent, 'Enable','on', 'ForegroundColor','k');
                parent = get(parent,'Parent');
            end
            
            % we open all (3 levels of) Children menus
            children1 = get(menu_handle,'Children');
            if ~isempty(children1)
                for i = 1 : length(children1)
                    set(children1(i), 'Enable','on', 'ForegroundColor','k');
                    children2 = get(children1(i),'Children');
                    if ~isempty(children2)
                        for j = 1 : length(children2)
                            set(children2(j), 'Enable','on', 'ForegroundColor','k');
                            children3 = get(children2(j),'Children');
                            if ~isempty(children3)
                                for k = 1 : length(children3)
                                    set(children3(k), 'Enable','on', 'ForegroundColor','k');
                                end
                            end
                        end
                    end
                end
            end
        end
    end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    function closemn(varargin)
        %CLOSEMN desables the menus and (3 levels of) sub-menus passed as handles
        %detailed in the list of handles in VARARGIN
        %
        varargin = varargin{:};
        nargin = length(varargin);
        for item = 1 : nargin
            menu_handle = varargin{item};
            % we close menu handle
            set(menu_handle, 'Enable','off', 'ForegroundColor',[.5 .5 .5]);
            % we close all (3 levels of) Children menus
            children1 = get(menu_handle,'Children');
            if ~isempty(children1)
                for i = 1 : length(children1)
                    set(children1(i), 'Enable','off', 'ForegroundColor',[.5 .5 .5]);
                    children2 = get(children1(i),'Children');
                    if ~isempty(children2)
                        for j = 1 : length(children2)
                            set(children2(j), 'Enable','off', 'ForegroundColor',[.5 .5 .5]);
                            children3 = get(children2(j),'Children');
                            if ~isempty(children3)
                                for k = 1 : length(children3)
                                    set(children3(k), 'Enable','off', 'ForegroundColor',[.5 .5 .5]);
                                end
                            end
                        end
                    end
                end
            end
        end
    end
end