classdef devFluorTags < uint8
    %DEVFLUORTAGS is a list of fluorometers supported by EEMlab
    %   Use: [members,names] = enumeration('devFluorTags')
    
    enumeration
        select                          (0) % STANDARD fluorometer. The EEM structure should match with the defined for this kind of devices
        STANDARD                        (1) % Horiba-PTI-QuantaMaster400, EPSA-UPV dataset
        Horiba_QuantaMaster             (2) % Horiba-PTI-QuantaMaster400, EPSA-UPV dataset
        Horiba_SpexFluorolog3           (3) % SPEX Fluorolog (HORIBA), drEEM dataset
        Horiba_FluoroMax                (4)
        Horiba_Aqualog                  (5) % Aqualog (HORIBA), G. GOLD dataset
        Agilent_VarianCaryEclipse       (6) % Varian Cary Eclipse (AGILENT), A. HECHAVARRIA dataset
        Jasco_FP8300                    (7) % FP8300 (JASCO), UCA (Universidad de Cdiz) dataset
        Hitachi_F2700                   (8)
    end
    
end