% The EEMlab Toolbox for MATLAB (ver. 0.2.4)
% Version 0.2.4 Feb-2021
% Download from http://pabmitor.webs.upv.es/eemlab
%
% Copyright EEMlab (C) 2016 Pau Mic
% Universitat Politcnica de Valncia
% Campus d'Alcoi
% Departament d'Informtica de Sistemes i Computadors
% SPAIN, pabmitor@upv.es
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation version 3 of the License <http://www.gnu.org/licenses/>
%
% This program is distributed in the hope that it will be useful, but WITHOUT 
% ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
% FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
% You should have received a copy of the GNU General Public License along with 
% this program; if not, write to the Free Software Foundation, Inc., 51 Franklin 
% Street, Fifth Floor, Boston, MA  02110-1301, USA.
%
%-----------------------------------------------
%GENERAL
%
%getfilesinfolder	returns a cell list with all the files contained in the folder (it also enalbles recursive listing of files)
%getlogtypes        generates the 'strings' parameter for drEEM's 'readlogfile'
%getrange           reads a CSV file and returns both, CSV size and its equivalent excel XLS range. Based on Matt G. 'xlsColNum2Str' (authorid:28897)
%targetsinlist      returns the items in the target list that are included in the list
%InterX             downloaded from http://es.mathworks.com/matlabcentral/fileexchange/22441-curve-intersections thanks to NS
%rmemptyfields     automatically looks for and removes empty fileds from a data struct
%
%-----------------------------------------------
%DATA IMPORT/EXPORT
%
%readxlslogfile     version of the same function in the drEEM that works with XLS and XLSX formats
%readineems4qms     imports QuantaMaster fluorometer TXT EEM files into Matlab (EEMs 3D matrix)
%readineems4jsc     imports Jasco FP-8300 fluorometer TXT EEM files into Matlab (EEMs 3D matrix)
%readinscans4qms    imports QuantaMaster fluorometer TXT SCAN (Raman) files into Matlab (EEM 2D matrix)
%readinscans4jsc    imports Jasco FP-8300 fluorometer TXT SCAN (Raman) files into Matlab (EEM 2D matrix)
%readinscans4hti    imports Hitachi spectrophotometer CSV SCAN (absorbance) files into Matlab (absorbances 3D matrix)
%readinscans4jen    imports Jenway 7315 spectrophotometer TXT SCAN (absorbance) files into Matlab (absorbances 3D matrix)
%qms2mat            imports a QuantaMaster fluorometer TXT EEM file into Matlab
%hti2mat            imports a Hitachi spectrophotometer CSV absorbance file into Matlab
%jen2mat            imports a Jenway 7315 spectrophotometer TXT absorbance file into Matlab
%jsc2mat            imports a Jasco FP-8300 fluorometer TXT EEM file into Matlab
%
%-----------------------------------------------
%SPECTRAL CORRECTION
%
%fdomcorrect024_spec    EEMlab version of the drEEM's FDOMCORRECT function that only apply spectrum correction to the raw data
%fdomcorrect024_ife     EEMlab version of the drEEM's FDOMCORRECT function that applies spectrum and inner filter effect corrections to the raw data
%fdomcorrect024_norm    EEMlab version of the drEEM's FDOMCORRECT function that applies spectrum and inner filter effect corrections and Raman normalization to the raw data
%fdomcorrect024_blk     EEMlab version of the drEEM's FDOMCORRECT function that applies spectrum and inner filter effect corrections, Raman normalization and blank subtraction to the raw data
%fdomcorrect024_qs      EEMlab version of the drEEM's FDOMCORRECT function that applies spectrum and inner filter effect corrections, Raman normalization, blank subtraction and QS calibration to the raw data
%                       this is the EEMlab version of the FULL drEEM's FDOMCORRECT function
%
%-----------------------------------------------
%SPECTRAL CORRECTION
%
%splitvalidation012 this is the EEMlab version of the drEEM's SPLITVALIDATION function
%                   SPLITVALIDATION012 includes as a user's input the Tucker correlation coefficient 'p'
%                   used for spectral match between spectrums
%
%-----------------------------------------------
%
% References:
% (1)   drEEM toolbox
%       Murphy K.R., Stedmon C.A., Graeber D. and R. Bro, Fluorescence
%       spectroscopy and multi-way techniques. PARAFAC, Anal. Methods, 
%       5, 6557-6566, 2013. DOI:10.1039/c3ay41160e. 
%
% (2) N-way toolbox
%     Andersson C. A. and R. Bro, Chemom. Intell. Lab. Syst., 2000, 52, 14.
%  
% $ Version 0.2.4 $ February 2021 $ First Release