%% EEMlab
% The _EEMlab Project_ (Excitation Emission Matrices laboratory) consists on
% developing a MATLABs Graphical User Interface (GUI) that fully supports 
% the _<http://www.models.life.ku.dk/dreem drEEM toolbox>_ (decomposition 
% routines for Excitation Emission Matrices). The join of both, the EEMlab 
% GUI plus the drEEM toolbox enable the researches an easy way to perform 
% PARAFAC analysis into fluorescence EEM datasets. Visit the 
% _<http://pabmitor.webs.upv.es/eemlab EEMlab Project's web>_ for getting 
% more information.

%% EEMlab Tutorial
% Get access to the _<http://pabmitor.webs.upv.es/wp-content/uploads/EEMlab/docs/1811_EEMlab_v012_Appendix_A.pdf EEMlab TUTORIAL>_
% that illustrates how to use EEMlab to process the drEEM dataset

%% Bibliography
% # J.R. Lakowicz, _Principles of Fluorescence Spectroscopy_, 3rd edition,
% Springer, Baltimore, Maryland, 2006
% # K.R.Murphy, K.D.Butler, R.G.M.Spencer, C.A.Stedmon, J.R.Boheme, G.R.Aiken,
% _Measurement of Dissolved Organic Matter Fluorescence in Aquatic Environments: 
% An Interlaboratory Comparison_,Environ. Sci. Technol., 44 (2010), 9405-9412
% # A.L. Lawaetz, C.A. Stedmon, _Fluorescence Intensity Calibration Using
% the Raman Scatter Peak of Water_, Appl. Spectrosc., vol. 63, number 8,
% (2009) 936-940
% # Murphy KR, Stedmon CA, Graeber D, Bro R., _Fluorescence spectroscopy
% and multi-way techniques. PARAFAC_, Analytical Methods 2013, 5, 6557-6566
% # A. Matilainena, E.T. Gjessingc, T. Lahtinend, L. Hede, A. Bhatnagarf, 
% M. Sillanp, _An overview of the methods used in the characterisation of natural
% organic matter (NOM) in relation to drinking water treatment_, Chemosphere
% Volume 83, Issue 11, June 2011, Pages 14311442
% # W. Chen, P. Westerhoff, J.A. Leenheer, K. Booksh, 
% _Fluorescence Excitation-Emission Matrix Regional Integration to
% Quantify Spectra for Dissolved Organic Matter_, Environ. Sci. Technol. 
% 2003, 37, 5701-5710

%% Public Databases
% * a fluorescence spectra database in _<http://www.openfluor.org OpenFluor>_
% * a spectral database of DOM in _<http://www.models.life.ku.dk/domfluor
% DomFluor>_
% * the spectroscopic properties of IHSS samples in
% _<http://www.humicsubstances.org/spectra.html Humic Substances>_

%% Glossary of Acronyms
% * DOM: Dissolved Organic Matter
% * drEEM: Decomposition Routines for Excitation Emission Matrices
% * EEMlab: Excitation Emission Matrices Laboratory
% * IHSS: International Humis Substances Society
% * PARAFAC: PARAllel FACtor analysis
% * QS: Quinine Sulfate
% * QSE: Quinine Sulfate Equivalent units
% * AU: Arbitrary Units
% * RU: Raman Units (at excitation 350 nm)
% * RU275: Raman Units (at excitation 275 nm)
% * RU350: Raman Units (at excitation 350 nm)
